/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   sebastian.bw@freenet.de                                                    
  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <math.h>
#include <stdlib.h>
#include "getcircle.h"

GetCircle::GetCircle()
{
}

GetCircle::~GetCircle()
{
}

long int GetCircle::get_r2y( long int r, long int x )
	{
	long int Y, X;
	div_t neu;
	
	X = 0;
	Y = r;
	while( X != x )
		{
		X ++;
		neu = div( ( r * r - X * X ), Y );
		if( neu.rem * 2 >= Y )
			neu.quot  ++;
		if( neu.quot < Y )
			Y --;
		}
	return Y;
	}

long int GetCircle::get_l2y( long int r, long int x, long int sx, long int sy )
	{
	long int Y, X;
	div_t neu;
	
	X = sx;
	Y = sy;
	while(  X != x )
		{
		X --;
		neu = div( ( r * r - X * X ), Y );
		if( neu.rem * 2 >= Y )
			neu.quot  ++;
		if( neu.quot > Y )
			Y ++;
		}
	return Y;
	}

long int GetCircle::get_l1x( long int r, long int y )
	{
	long int Y, X;
	div_t neu;
	
	X = r;
	Y = 0;
	while(  Y != y )
		{
		Y ++;
		neu = div( ( r * r - Y * Y ), X );
		if( neu.rem * 2 >= X )
			neu.quot  ++;
		if( neu.quot < X )
			X --;
		}
	return X;
	}

long int GetCircle::get_r1x( long int r, long int y, long int sx, long int sy )
	{
	long int Y, X;
	div_t neu;
	
	X = sy;
	Y = sx;
	while(  Y != y )
		{
		Y --;
		neu = div( ( r * r - Y * Y ), X );
		if( neu.rem * 2 >= X )
			neu.quot  ++;
		if( neu.quot > X )
			X ++;
		}
	return X;
	}

QString GetCircle::getCircle( uint mf, double r, char *kdev, double pr, char s1, double x1, double y1, char s2, double x2, double y2, CircleData *cd )
	{
	long int sx, sy, r2, s=0, X1, Y1, X2, Y2;
	double dx=0, dy=0;
	QString li;
	div_t xn;
	
	sy = 0;
	sx = long( round( r * mf * 100.00 ) );
	//KMessageBox::messageBox ( 0, KMessageBox::Information, QString("sx =  %1\nr =  %2").arg(sx).arg(r), "Info");
	r2 = sx * sx;
	while( sy < sx )
		{
		sy ++;
		xn = div( ( r2 - sy * sy ), sx );
		if( xn.rem * 2 >= sx )
			xn.quot  ++;
		if( sx > xn.quot  )
			sx --;
		//KMessageBox::messageBox ( 0, KMessageBox::Information, QString("sx =  %1\nxn =  %2\nsy =  %3").arg(sx).arg(xn.quot).arg(sy), "Info");
		}
	
	X1 = long( round( x1 * mf * 100.00 ) );
	Y1 = long( round( y1 * mf * 100.00 ) );
	X2 = long( round( x2 * mf * 100.00 ) );
	Y2 = long( round( y2 * mf * 100.00 ) );
	
	if( kdev[5] == '0' )   // left around
		switch ( s1 )
			{
			case 1:
				if( x1 > y1 )
					{
					kdev[2] = '0';
					kdev[3] = '0';
					kdev[4] = '0';
					x1 = get_l1x( long( round( r * mf * 100.00 ) ), Y1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if( x2 > y2 )
								{
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								if( y1 >= y2 )
									{   // from sec1 to sec1
									s = sy - Y1 + 4 * sx + 3 * sy + Y2;
									}
								else
									{   // from sec1 to sec1
									s = Y2 - Y1;
									}
								}
							else
								{   // from sec1 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + sx - X2;
								}
							dx = x2 - x1;
							dy = y2 - y1;
							break;
							
						case 2:
							if( x2 < y2 )
								{   // from sec1 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + sx + X2;
								}
							else
								{   // from sec1 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y2 - y1;
							break;
							
						case 3:
							if( x2 > y2 )
								{   // from sec1 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy + Y2;
								}
							else
								{   // from sec1 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s =  sy - Y1 + 2 * sx + 2 * sy + sx - X2;
								}
							dx = - ( x1 + x2 );
							dy = - ( y1 + y2 );
							break;
							
						case 4:
							if( x2 < y2 )
								{   // from sec1 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + 3 * sx + 2 * sy + X2;
								}
							else
								{   // from sec1 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 4 * sx + 2 * sy + abs( sy - Y2 );
								}
							dx = x2 - x1;
							dy = - ( y1 + y2 );
							break;
						}
					}
				else
					{
					kdev[2] = '1';
					kdev[3] = '0';
					kdev[4] = '0';
					y1 = get_l2y( long( round( r * mf * 100.00 ) ), X1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if( x2 > y2 )
								{   // from sec2 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 3 * sy + Y2;
								}
							else
								{
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								if( x1 <= x2 )
									{   // from sec2 to sec2
									s = X1 + 3 * sx + 4 * sy + sx - X2;
									}
								else
									{   // from sec2 to sec2   y2 > y1
									s = X1 - X2;
									}
								}
							dx = x2 - x1;
							dy = y2 - y1;
							break;
							
						case 2:
							if( x2 < y2 )
								{   // from sec2 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 +  X2;
								}
							else
								{   // from sec2 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y2 - y1;
							break;
							
						case 3:
							if( x2 > y2 )
								{   // from sec2 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + sx + sy + Y2;
								}
							else
								{   // from sec2 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + 2 * sy + sx - X2;
								}
							dx = - ( x1 + x2 );
							dy = - ( y1 + y2 );
							break;
							
						case 4:
							if( x2 < y2 )
								{   // from sec2 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 + 2 * sx + 2 * sy + X2;
								}
							else
								{   // from sec2 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 2 * sy + sy - Y2;
								}
							dx = x2 - x1;
							dy = - ( y1 + y2 );
							break;
						}
					}
				break;
				
			case 2:
				if( x1 < y1 )
					{
					kdev[2] = '1';
					kdev[3] = '0';
					kdev[4] = '1';
					y1 = get_r2y( long( round( r * mf * 100.00 ) ), X1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if( x2 > y2 )
								{   // from sec3 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 3 * sy + Y2;
								}
								
							else
								{   // from sec3 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 4 * sy + sx - X2;
								}
							dx =  x1 + x2;
							dy = y2 - y1;
							break;
							
						case 2:
							if( x2 < y2 )
								{
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								if( x1 >= x2 )
									{   // from sec3 to sec3
									s = sx - X1 + 3 * sx + 4 * sy + X2;
									}
								else
									{   // from sec3 to sec3
									s = X2 - X1;
									}
								}
							else
								{   // from sec3 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + sy - Y2;
								}
							dx = x1 - x2;
							dy = y2 - y1;
							break;
							
						case 3:
							if( x2 > y2 )
								{   // from sec3 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + sy + Y2;
								}
							else
								{   // from sec3 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx - X2;
								}
							dx = x1 - x2;
							dy = - ( y1 + y2 );
							break;
							
						case 4:
							if( x2 < y2 )
								{   // from sec3 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx + X2;
								}
							else
								{   // from sec3 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + 2 * sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = - ( y1 + y2 );
							break;
						}
					}
				else
					{
					kdev[2] = '0';
					kdev[3] = '0';
					kdev[4] = '1';
					x1 = get_r1x( long( round( r * mf * 100.00 ) ), Y1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if( x2 > y2 )
								{   // from sec4 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 2 * sy + Y2;
								}
							else
								{   // from sec4 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 3 * sy + sx - X2;
								}
							dx = x1 + x2;
							dy = y2 - y1;
							break;
							
						case 2:
							if( x2 < y2 )
								{   // from sec4 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + 3 * sx + 3 * sy + X2;
								}
							else
								{
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								if( y1 <= y2 )
									{   // from sec4 to sec4
									s = Y1 + 4 * sx + 3 * sy + sy - Y2;
									}
								else
									{   // from sec4 to sec4
									s = abs( Y1 - Y2 );
									}
								}
							dx = x1 - x2;
							dy = y2 - y1;
							break;
							
						case 3:
							if( x2 > y2 )
								{   // from sec4 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + Y2;
								}
							else
								{   // from sec4 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + sy + sx - X2;
								}
							dx = x1 - x2;
							dy = - ( y1 + y2 );
							break;
							
						case 4:
							if( x2 < y2 )
								{   // from sec4 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + sy + sx + X2;
								}
							else
								{   // from sec4 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + sy + sy - Y2;
								}
							dx = x1 + x2;
							dy = - ( y1 + y2 );
							break;
						}
					}
				break;
			
			case 3:
				if( x1 > y1 )
					{
					kdev[2] = '0';
					kdev[3] = '1';
					kdev[4] = '1';
					x1 = get_l1x( long( round( r * mf * 100.00 ) ), Y1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if( x2 > y2 )
								{   // from sec5 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy + Y2;
								}
							else
								{   // from sec5 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + 2 * sy + sx - X2;
								}
							dx = x1 + x2;
							dy = y1 + y2;
							break;
							
						case 2:
							if( x2 < y2 )
								{   // from sec5 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + 3 * sx + 2 * sy + X2;
								}
							else
								{   // from sec5 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 4 * sx + 2 * sy + sy - Y2;
								}
							dx = x1 - x2;
							dy = y1 + y2;
							break;
							
						case 3:
							if( x2 > y2 )
								{
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								if( y1 >= y2 )
									{   // from sec5 to sec5
									s = sy - Y1 + 4 * sx + 3 * sy + Y2;
									}
								else
									{   // from sec5 to sec5   y2 > y1
									s = abs( Y1 - Y2 );
									}
								}
							else
								{   // from sec5 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + sx - X2;
								}
							dx = x1 - x2;
							dy = y1 - y2;
							break;
							
						case 4:
							if( x2 < y2 )
								{   // from sec5 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + sx + X2;
								}
							else
								{   // from sec5 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = y1 - y2;
							break;
						}
					}
				else
					{
					kdev[2] = '1';
					kdev[3] = '1';
					kdev[4] = '1';
					y1 = get_l2y( long( round( r * mf * 100.00 ) ), X1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if( x2 > y2 )
								{   // from sec6 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + sx + sy + Y2;
								}
							else
								{   // from sec6 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + 2 * sy + sx - X2;
								}
							dx = x1 + x2;
							dy = y1 + y2;
							break;
							
						case 2:
							if( x2 < y2 )
								{   // from sec6 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 + 2 * sx + 2 * sy + X2;
								}
							else
								{   // from sec6 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 2 * sy + sy - Y2;
								}
							dx = x1 - x2;
							dy = y1 + y2;
							break;
							
						case 3:
							if( x2 > y2 )
								{   // from sec6 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 3 * sy + Y2;
								}
							else
								{
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								if( x1 <= x2 )
									{   // from sec6 to sec6
									s = X1 + 3 * sx + 4 * sy + sx - X2;
									}
								else
									{   // from sec6 to sec6
									s = X1 - X2;
									}
								}
							dx = x1 - x2;
							dy = y1 - y2;
							break;
							
						case 4:
							if( x2 < y2 )
								{   // from sec6 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 +  X2;
								}
							else
								{   // from sec6 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = y1 - y2;
							break;
						}
					}
				break;
			
			case 4:
				if( x1 < y1 )
					{
					kdev[2] = '1';
					kdev[3] = '1';
					kdev[4] = '0';
					y1 = get_r2y( long( round( r * mf * 100.00 ) ), X1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if( x2 > y2 )
								{   // from sec7 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + sy + Y2;
								}
							else
								{   // from sec7 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx - X2;
								}
							dx = x2 - x1;
							dy = y1 + y2;
							break;
							
						case 2:
							if( x2 < y2 )
								{   // from sec7 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx + X2;
								}
							else
								{   // from sec7 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + 2 * sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y1 + y2;
							break;
							
						case 3:
							if( x2 > y2 )
								{   // from sec7 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 3 * sy + Y2;
								}
								
							else
								{   // from sec7 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 4 * sy + sx - X2;
								}
							dx =  - ( x1 + x2 );
							dy = y1 - y2;
							break;
							
						case 4:
							if( x2 < y2 )
								{
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								if( x1 >= x2 )
									{   // from sec7 to sec7
									s = sx - X1 + 3 * sx + 4 * sy + X2;
									}
								else
									{   // from sec7 to sec7
									s = X2 - X1;
									}
								}
							else
								{   // from sec7 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + sy - Y2;
								}
							dx = x2 - x1;
							dy = y1 - y2;
							break;
						}
					}
				else
					{
					kdev[2] = '0';
					kdev[3] = '1';
					kdev[4] = '0';
					x1 = get_r1x( long( round( r * mf * 100.00 ) ), Y1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if( x2 > y2 )
								{   // from sec8 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + Y2;
								}
							else
								{   // from sec8 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + sy + sx - X2;
								}
							dx = x2 - x1;
							dy = y1 + y2;
							break;
							
						case 2:
							if( x2 < y2 )
								{   // from sec8 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + sy + sx + X2;
								}
							else
								{   // from sec8 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + sy + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y1 + y2;
							break;
							
						case 3:
							if( x2 > y2 )
								{   // from sec8 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 2 * sy + Y2;
								}
							else
								{   // from sec8 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 3 * sy + sx - X2;
								}
							dx = - ( x1 + x2 );
							dy = y1 - y2;
							break;
							
						case 4:
							if( x2 < y2 )
								{   // from sec8 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + 3 * sx + 3 * sy + X2;
								}
							else
								{
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								if( y1 <= y2 )
									{   // from sec8 to sec8
									s = Y1 + 4 * sx + 3 * sy + sy - Y2;
									}
								else
									{   // from sec8 to sec8
									s = abs( Y1 - Y2 );
									}
								}
							dx = x2 - x1;
							dy = y1 - y2;
							break;
						}
					}
			}

//-------------------------------------------------------------------

	else   // right around
		switch ( s1 )
			{
			case 4:
				if( x1 > y1 )
					{
					kdev[2] = '0';
					kdev[3] = '1';
					kdev[4] = '0';
					x1 = get_l1x( long( round( r * mf * 100.00 ) ), Y1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if( x2 > y2 )
								{
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								if( y1 >= y2 )
									{   // from sec8 to sec8
									s = sy - Y1 + 4 * sx + 3 * sy + Y2;
									}
								else
									{   // from sec8 to sec8   y2 > y1
									s = abs( Y1 - Y2 );
									}
								}
							else
								{   // from sec8 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + sx - X2;
								}
							dx = x2 - x1;
							dy = y1 - y2;
							break;
							
						case 3:
							if( x2 < y2 )
								{   // from sec8 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + sx + sx - X2;
								}
							else
								{   // from sec8 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y1 - y2;
							break;
							
						case 2:
							if( x2 > y2 )
								{   // from sec8 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy + Y2;
								}
							else
								{   // from sec8 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y1 + y2;
							break;
							
						case 1:
							if( x2 < y2 )
								{   // from sec8 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + 3 * sx + 2 * sy + X2;
								}
							else
								{   // from sec8 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 4 * sx + 2 * sy + sy - Y2;
								}
							dx = x2 - x1;
							dy = y1 + y2;
							break;
						}
					}
				else
					{
					kdev[2] = '1';
					kdev[3] = '1';
					kdev[4] = '0';
					y1 = get_l2y( long( round( r * mf * 100.00 ) ), X1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if( x2 > y2 )
								{   // from sec7 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 4 * sy + Y2;
								}
							else
								{
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								if( x1 <= x2 )
									{   // from sec7 to sec7
									s = X1 + 3 * sx + 4 * sy + sx - X2;
									}
								else
									{   // from sec7 to sec7   y2 > y1
									s = X1 - X2;
									}
								}
							dx = x2 - x1;
							dy = y1 - y2;
							break;
							
						case 3:
							if( x2 < y2 )
								{   // from sec7 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 +  X2;
								}
							else
								{   // from sec7 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y1 - y2;
							break;
							
						case 2:
							if( x2 > y2 )
								{   // from sec7 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + sx + sy + Y2;
								}
							else
								{   // from sec7 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + 2 * sy + sx - X2;
								}
							dx = - ( x1 + x2 );
							dy = y1 + y2;
							break;
							
						case 1:
							if( x2 < y2 )
								{   // from sec7 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 + 2 * sx + 2 * sy + X2;
								}
							else
								{   // from sec7 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 2 * sy + sy - Y2;
								}
							dx = x2 - x1;
							dy = y1 + y2;
							break;
						}
					}
				break;
				
			case 3:
				if( x1 < y1 )
					{
					kdev[2] = '1';
					kdev[3] = '1';
					kdev[4] = '1';
					y1 = get_r2y( long( round( r * mf * 100.00 ) ), X1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if( x2 > y2 )
								{   // from sec6 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 3 * sy + Y2;
								}
								
							else
								{   // from sec6 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 4 * sy + sx - X2;
								}
							dx =  x1 + x2;
							dy = y1 - y2;
							break;
							
						case 3:
							if( x2 < y2 )
								{
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								if( x1 >= x2 )
									{   // from sec6 to sec6
									s = sx - X1 + 3 * sx + 4 * sy + X2;
									}
								else
									{   // from sec6 to sec6
									s = X2 - X1;
									}
								}
							else
								{   // from sec6 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + sy - Y2;
								}
							dx = x1 - x2;
							dy = y1 - y2;
							break;
							
						case 2:
							if( x2 > y2 )
								{   // from sec6 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + sy + Y2;
								}
							else
								{   // from sec6 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx - X2;
								}
							dx = x1 - x2;
							dy = y1 + y2;
							break;
							
						case 1:
							if( x2 < y2 )
								{   // from sec6 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx + X2;
								}
							else
								{   // from sec6 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + 2 * sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = y1 + y2;
							break;
						}
					}
				else
					{
					kdev[2] = '0';
					kdev[3] = '1';
					kdev[4] = '1';
					x1 = get_r1x( long( round( r * mf * 100.00 ) ), Y1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if( x2 > y2 )
								{   // from sec5 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 2 * sy + Y2;
								}
							else
								{   // from sec5 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 3 * sy + sx - X2;
								}
							dx = x1 + x2;
							dy = y1 - y2;
							break;
							
						case 3:
							if( x2 < y2 )
								{   // from sec5 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + 3 * sx + 3 * sy + X2;
								}
							else
								{
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								if( y1 <= y2 )
									{   // from sec5 to sec5
									s = Y1 + 4 * sx + 3 * sy + sy - Y2;
									}
								else
									{   // from sec5 to sec5
									s = abs( Y1 - Y2 );
									}
								}
							dx = x1 - x2;
							dy = y1 - y2;
							break;
							
						case 2:
							if( x2 > y2 )
								{   // from sec5 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + Y2;
								}
							else
								{   // from sec5 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + sy + sx - X2;
								}
							dx = x1 - x2;
							dy = y1 + y2;
							break;
							
						case 1:
							if( x2 < y2 )
								{   // from sec5 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + sy + sx + X2;
								}
							else
								{   // from sec5 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + sy + sy - Y2;
								}
							dx = x1 + x2;
							dy = y1 + y2;
							break;
						}
					}
				break;
			
			case 2:
				if( x1 > y1 )
					{
					kdev[2] = '0';
					kdev[3] = '0';
					kdev[4] = '1';
					x1 = get_l1x( long( round( r * mf * 100.00 ) ), Y1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if( x2 > y2 )
								{   // from sec4 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy + Y2;
								}
							else
								{   // from sec4 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = - ( y1 + y2 );
							break;
							
						case 3:
							if( x2 < y2 )
								{   // from sec4 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + 3 * sx + 2 * sy + X2;
								}
							else
								{   // from sec4 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 4 * sx + 2 * sy + sy - Y2;
								}
							dx = x1 - x2;
							dy = - ( y1 + y2 );
							break;
							
						case 2:
							if( x2 > y2 )
								{
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								if( y1 >= y2 )
									{   // from sec4 to sec4
									s = sy - Y1 + 4 * sx + 3 * sy + Y2;
									}
								else
									{   // from sec4 to sec4   y2 > y1
									s = abs( Y1 - Y2 );
									}
								}
							else
								{   // from sec4 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + sx - X2;
								}
							dx = x1 - x2;
							dy = y2 - y1;
							break;
							
						case 1:
							if( x2 < y2 )
								{   // from sec4 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + sx + sx - X2;
								}
							else
								{   // from sec4 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = y2 - y1;
							break;
						}
					}
				else
					{
					kdev[2] = '1';
					kdev[3] = '0';
					kdev[4] = '1';
					y1 = get_l2y( long( round( r * mf * 100.00 ) ), X1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if( x2 > y2 )
								{   // from sec3 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + sx + sy + Y2;
								}
							else
								{   // from sec3 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + 2 * sy + sx - X2;
								}
							dx = x1 + x2;
							dy = y1 + y2;
							break;
							
						case 3:
							if( x2 < y2 )
								{   // from sec3 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 + 2 * sx + 2 * sy + X2;
								}
							else
								{   // from sec3 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 2 * sy + sy - Y2;
								}
							dx = x1 - x2;
							dy = y1 + y2;
							break;
							
						case 2:
							if( x2 > y2 )
								{   // from sec3 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 4 * sy + Y2;
								}
							else
								{
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								if( x1 <= x2 )
									{   // from sec3 to sec3
									s = X1 + 3 * sx + 4 * sy + sx - X2;
									}
								else
									{   // from sec3 to sec3
									s = X1 - X2;
									}
								}
							dx = x1 - x2;
							dy = y1 - y2;
							break;
							
						case 1:
							if( x2 < y2 )
								{   // from sec3 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 +  X2;
								}
							else
								{   // from sec3 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = y1 - y2;
							break;
						}
					}
				break;
			
			case 1:
				if( x1 < y1 )
					{
					kdev[2] = '1';
					kdev[3] = '0';
					kdev[4] = '0';
					y1 = get_r2y( long( round( r * mf * 100.00 ) ), X1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if( x2 > y2 )
								{   // from sec2 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + sy + Y2;
								}
							else
								{   // from sec2 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx - X2;
								}
							dx = x2 - x1;
							dy = - ( y1 + y2 );
							break;
							
						case 3:
							if( x2 < y2 )
								{   // from sec2 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx + X2;
								}
							else
								{   // from sec2 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + 2 * sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = - ( y1 + y2 );
							break;
							
						case 2:
							if( x2 > y2 )
								{   // from sec2 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 3 * sy + Y2;
								}
								
							else
								{   // from sec2 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 4 * sy + sx - X2;
								}
							dx =  - ( x1 + x2 );
							dy = y2 - y1;
							break;
							
						case 1:
							if( x2 < y2 )
								{
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								if( x1 >= x2 )
									{   // from sec2 to sec2
									s = sx - X1 + 3 * sx + 4 * sy + X2;
									}
								else
									{   // from sec2 to sec2
									s = X2 - X1;
									}
								}
							else
								{   // from sec2 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + sy - Y2;
								}
							dx = x2 - x1;
							dy = y2 - y1;
							break;
						}
					}
				else
					{
					kdev[2] = '0';
					kdev[3] = '0';
					kdev[4] = '0';
					x1 = get_r1x( long( round( r * mf * 100.00 ) ), Y1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if( x2 > y2 )
								{   // from sec1 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + Y2;
								}
							else
								{   // from sec1 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + sy + sx - X2;
								}
							dx = x2 - x1;
							dy = y1 + y2;
							break;
							
						case 3:
							if( x2 < y2 )
								{   // from sec1 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + sy + sx + X2;
								}
							else
								{   // from sec1 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + sy + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y1 + y2;
							break;
							
						case 2:
							if( x2 > y2 )
								{   // from sec1 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 2 * sy + Y2;
								}
							else
								{   // from sec1 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 3 * sy + sx - X2;
								}
							dx = - ( x1 + x2 );
							dy = y2 - y1;
							break;
							
						case 1:
							if( x2 < y2 )
								{   // from sec1 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + 3 * sx + 3 * sy + X2;
								}
							else
								{
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								if( y1 <= y2 )
									{   // from sec1 to sec1
									s = Y1 + 4 * sx + 3 * sy + sy - Y2;
									}
								else
									{   // from sec1 to sec1
									s = abs( Y1 - Y2 );
									}
								}
							dx = x2 - x1;
							dy = y2 - y1;
							break;
						}
					}
			}

	cd->set_steps( s );
	li = " kreisdev	";
	li += kdev;
	li += "\n przision	" + QString::number( pr, 'f', 2 )+"\n";
	if( kdev[6] == '0' & kdev[7] == '0' )   // around Z
		{
		li += " x	" + QString::number( x1, 'f', 2 )+"\n y	" + QString::number( y1, 'f', 2 )+"\n radius	" + QString::number( r, 'f', 2 )+"\n schritte	" + QString::number( s )+"\n- dx="+QString::number( dx, 'f', 3 )+"  dy="+QString::number( dy, 'f', 3 )+"\n";
		cd->set_deltax( dx );
		cd->set_deltay( dy );
		cd->set_deltaz ( 0 );
		}
	else
	if( kdev[6] == '0' & kdev[7] == '1' )   // around Y
		{
		li += " x	" + QString::number( x1, 'f', 2 )+"\n z	" + QString::number( y1, 'f', 2 )+"\n radius	" + QString::number( r, 'f', 2 )+"\n schritte	" + QString::number( s )+"\n- dx="+QString::number( dx, 'f', 3 )+"  dz="+QString::number( dy, 'f', 3 )+"\n";
		cd->set_deltax( dx );
		cd->set_deltay( 0 );
		cd->set_deltaz( dy );
		}
	else
	if( kdev[6] == '1' & kdev[7] == '0' )   // around X
		{
		li += " y	" + QString::number( x1, 'f', 2 )+"\n z	" + QString::number( y1, 'f', 2 )+"\n radius	" + QString::number( r, 'f', 2 )+"\n schritte	" + QString::number( s )+"\n- dy="+QString::number( dx, 'f', 3 )+"  dz="+QString::number( dy, 'f', 3 )+"\n";
		cd->set_deltax( 0 );
		cd->set_deltay( dx );
		cd->set_deltaz( dy );
		}
	
	if( pr > 0 )
		{
		cd->set_n( long( round( s / ( pr *100 * mf ) ) ) );
		li += "- n=" + QString::number( cd->n ) + "\n";
		}
	else
		cd->set_n( 0 );
	
	return li;
	}


