/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   sebastian.bw@freenet.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

//#include "getcurrentpos.inc"

int getcurrentpos( QTextEdit *editor, int pos, double *x, double *y, double *z)
	{
	int i, n, LineIgnore, p;
	bool OK;
	double sx[255], sy[255], sz[255], anz, dx, dy, dz;
	QString s;
	
	OK=TRUE;
	*x = 0; *y = 0; *z = 0;
	i = 0; n = 0; LineIgnore=0;
	
	while ( i < pos )
		{
		s = editor->text(i);
		if( s.isEmpty() )
			return -1;
		i++;
		s = s.stripWhiteSpace();
		if( s.at(0) == '-' );
		else
		if( ! s.compare("ENDE") )
			return( i - 1 );
		else
		if( ! s.compare( "LINIE" ) )
			{
			if( LineIgnore > 0 )
				{
				LineIgnore --;
				i += 3;
				}
			else
				{
				s = editor->text(i);
				i++;
				p = s.find( '	' ) + 1;
				s.remove( 0, p );
				s = s.stripWhiteSpace();
				if( s.isEmpty() )
					return( i - 1 );
				*x += s.toDouble( &OK );
				if( ! OK )
					return( i - 1 );
	
				s = editor->text(i);
				i++;
				p = s.find( '	' ) + 1;
				s.remove( 0, p );
				s = s.stripWhiteSpace();
				if( s.isEmpty() )
					return( i - 1 );
				*y += s.toDouble( &OK );
				if( ! OK )
					return( i - 1 );
					
				s = editor->text(i);
				i++;
				p = s.find( '	' ) + 1;
				s.remove( 0, p );
				s = s.stripWhiteSpace();
				if( s.isEmpty() )
					return( i - 1 );
				*z += s.toDouble( &OK );
				if( ! OK )
					return( i - 1 );
				}
			}
		else
		if( ! s.compare ( "LINIEX" ) )
			{
			s = editor->text(i);
			i++;
			p = s.find( '	' ) + 1;
			s.remove( 0, p );
			s = s.stripWhiteSpace();
			if( s.isEmpty() )
				return( i - 1 );
			*x += s.toDouble( &OK );
			if( ! OK )
				return( i - 1 );
			}
		else
		if( ! s.compare ( "LINIEY" ) )
			{
			s = editor->text(i);
			i++;
			p = s.find( '	' ) + 1;
			s.remove( 0, p );
			s = s.stripWhiteSpace();
			if( s.isEmpty() )
				return( i - 1 );
			*y += s.toDouble( &OK );
			if( ! OK )
				return( i - 1 );
			}
		else
		if( ! s.compare ( "LINIEZ" ) )
			{
			s = editor->text(i);
			i++;
			p = s.find( '	' ) + 1;
			s.remove( 0, p );
			s = s.stripWhiteSpace();
			if( s.isEmpty() )
				return( i - 1 );
			*z += s.toDouble( &OK );
			if( ! OK )
				return( i - 1 );
			}
		else
		if( ! s.compare ( "KREIS" ) )
			{
			i += 6;
			s = editor->text(i);
			i++;
			s = s.stripWhiteSpace();
			if( s.at( 0 ) == '-' )
				{
				dx = 0; dy = 0; dz = 0;
				if( s.find( 'z' ) != -1 )
					{
					s.remove( 0, s.find( 'z' )+2 );
					s = s.stripWhiteSpace();
					dz = s.toDouble( &OK );
					if( ! OK )
						return( i );
					s = editor->text(i);
					s.remove( s.find( 'z' )-1, s.length() );
					if( s.find( 'y' ) != -1 )
						{
						s.remove( 0, s.find( 'y' )+2 );
						s = s.stripWhiteSpace();
						dy = s.toDouble( &OK );
						if( ! OK )
							return( i );
						}
					else
					if( s.find( 'x' ) != -1 )
						{
						s.remove( 0, s.find( 'y' )+2 );
						s = s.stripWhiteSpace();
						dx = s.toDouble( &OK );
						if( ! OK )
							return( i );
						}
					}
				else
				if( s.find( 'y' ) != -1 )
					{
					s.remove( 0, s.find( 'y' )+2 );
					s = s.stripWhiteSpace();
					dy = s.toDouble( &OK );
					if( ! OK )
						return( i );
					s = editor->text(i);
					s.remove( s.find( 'y' )-1, s.length() );
					if( s.find( 'x' ) != -1 )
						{
						s.remove( 0, s.find( 'x' )+2 );
						s = s.stripWhiteSpace();
						dx = s.toDouble( &OK );
						if( ! OK )
							return( i );
						}
					}
				
				s = editor->text(i);
				s = s.stripWhiteSpace();
				if( s.at( 0 ) == '-' )
					{
					i++;
					if( s.find( 'n' ) != -1 )
						{
						s.remove( 0, s.find( 'n' )+2 );
						int anz = s.toInt( &OK );
						if( ! OK )
							return( i );
						
						if( anz == 0 )
							anz = 1;
						
						*x += dx / anz;
						*y += dy / anz;
						*z += dz / anz;
						}
					}
				else
					{
					*x += dx;
					*y += dy;
					*z += dz;
					}
				}
			}
		else
		if( ! s.compare ( "ELLIPSE" ) )
			{
			i += 7;
			s = editor->text(i);
			i++;
			s = s.stripWhiteSpace();
			if( s.at( 0 ) == '-' )
				{
				dx = 0; dy = 0; dz = 0;
				if( s.find( 'z' ) != -1 )
					{
					s.remove( 0, s.find( 'z' )+2 );
					s = s.stripWhiteSpace();
					dz = s.toDouble( &OK );
					if( ! OK )
						return( i );
					s = editor->text(i);
					s.remove( s.find( 'z' )-1, s.length() );
					if( s.find( 'y' ) != -1 )
						{
						s.remove( 0, s.find( 'y' )+2 );
						s = s.stripWhiteSpace();
						dy = s.toDouble( &OK );
						if( ! OK )
							return( i );
						}
					else
					if( s.find( 'x' ) != -1 )
						{
						s.remove( 0, s.find( 'y' )+2 );
						s = s.stripWhiteSpace();
						dx = s.toDouble( &OK );
						if( ! OK )
							return( i );
						}
					}
				else
				if( s.find( 'y' ) != -1 )
					{
					s.remove( 0, s.find( 'y' )+2 );
					s = s.stripWhiteSpace();
					dy = s.toDouble( &OK );
					if( ! OK )
						return( i );
					s = editor->text(i);
					s.remove( s.find( 'y' )-1, s.length() );
					if( s.find( 'x' ) != -1 )
						{
						s.remove( 0, s.find( 'x' )+2 );
						s = s.stripWhiteSpace();
						dx = s.toDouble( &OK );
						if( ! OK )
							return( i );
						}
					}
				*x += dx;
				*y += dy;
				*z += dz;
				}
			}
		else
		if( ! s.compare ( "WARTE" ) );
		else
		if( ! s.compare ( "STEUERUNG" ) )
			i++;
		else
		if( ! s.compare ( "SPIEL" ) )
			i += 3;
		else
		if( ! s.compare ( "KREISFUNKTION" ) )
			i += 6;
		else
		if( ! s.compare ( "ELLIPSENFUNKTION" ) )
			i += 7;
		else
		if( ! s.compare ( "SCHLEIFE{" ) )
			{
			sx[n] = *x;
			sy[n] = *y;
			sz[n] = *z;
			n++;
			}
		else
		if( ! s.compare ( "}SCHLEIFE" ) )
			{
			s = editor->text(i);
			i++;
			p = s.find( '	' ) + 1;
			s.remove( 0, p );
			s = s.stripWhiteSpace();
			if( s.isEmpty() )
				return( i - 1 );
			anz = s.toDouble( &OK );
			if( ! OK )
				return( i - 1 );
			
			n--;
			*x += ( *x - sx[n] ) * anz;
			*y += ( *y - sy[n] ) * anz;
			*z += ( *z - sz[n] ) * anz;
			}
		else
		if( ! s.compare ( "DELTAKREIS" ) )
			i ++;
		else
		if( ! s.compare ( "DELTAELLIPS" ) )
			i ++;
		else
		if( ! s.compare ( "VORSCHUB" ) )
			i ++;
		else
		if( ! s.compare ( "DELTALINEAR" ) )
			i += 2;
		else
		if( ! s.compare ( "WERKZEUGWECHSEL" ) )
			{
			i ++;
			LineIgnore = 2;
			}
		}
	
	return 0;
	}

